const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const product_categories = sequelize.define(
    'product_categories',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

category_name: {
        type: DataTypes.TEXT,
      
      

      },

category_description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  product_categories.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.product_categories.hasMany(db.products, {
      as: 'products_category',
      foreignKey: {
          name: 'categoryId',
      },
      constraints: false,
    });

















//end loop



    db.product_categories.belongsTo(db.product_categories, {
      as: 'parent_category',
      foreignKey: {
        name: 'parent_categoryId',
      },
      constraints: false,
    });




    db.product_categories.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.product_categories.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return product_categories;
};


